<template>
    <nav class="navbar navbar-expand-md sticky-top navbar-dark bg-dark">
        <div class="container">
            <inertia-link class="navbar-brand" href="/">{{ serverName }}</inertia-link>
            <button class="navbar-toggler collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#navbar">
                <span class="navbar-toggler-icon"></span>
            </button>
            
            <div class="navbar-collapse collapse d-md-flex justify-content-between" id="navbar">
                <ul class="navbar-nav">
                    <nav-item :href="route('dashboard')" :active="route().current('dashboard')">Dashboard</nav-item>
                    <nav-item :href="route('leaderboard')" :active="route().current('leaderboard')">Leaderboard</nav-item>
                    <nav-item :href="route('maps')" :active="route().current('maps')">Maps</nav-item>
                </ul>
                
                <ul v-if="user" class="navbar-nav">
                    <nav-dropdown text="Manage Server" :active="route().current('server.*')">
                        <nav-dropdown-item :href="route('server.settings.index')" :active="route().current('server.settings.index')">Settings</nav-dropdown-item>
                        <nav-dropdown-item :href="route('server.admins.get')" :active="route().current('server.admins.*')">Admins</nav-dropdown-item>
                        <nav-dropdown-item :href="route('server.mutes.get')" :active="route().current('server.mutes.*')">Mutes</nav-dropdown-item>
                        <nav-dropdown-item :href="route('server.maps.index')" :active="route().current('server.maps.*')">Maps</nav-dropdown-item>
                        <nav-dropdown-item :href="route('server.skins.index')" :active="route().current('server.skins.*')">Skins</nav-dropdown-item>
                    </nav-dropdown>
                    
                    <nav-item v-if="user.manage_users" :href="route('users.index')" :active="route().current('users.*')">Panel Users</nav-item>
                    
                    <nav-dropdown :text="user.username">
                        <nav-dropdown-item :href="route('auth.logout')" method="post" as="button" type="button">Logout</nav-dropdown-item>
                    </nav-dropdown>
                </ul>
                <ul v-else class="navbar-nav">
                    <nav-item :href="route('auth.login')" :active="route().current('auth.login')">Login</nav-item>
                </ul>
            </div>
        </div>
    </nav>
    
    <div class="container-lg shadow-lg p-4">
        <slot></slot>
    </div>
</template>

<script>
    import NavItem from '@/Components/NavItem'
    import NavDropdown from '@/Components/NavDropdown'
    import NavDropdownItem from '@/Components/NavDropdownItem'

    export default {
        props: {
            'title': String,
            'serverName': String,
            'user': Object,
        },
        
        components: {
            NavItem,
            NavDropdown,
            NavDropdownItem,
        },
        
        watch: {
            title: {
                immediate: true,
                handler(title) {
                    document.title = this.serverName + (title ? ' - ' + title : '');
                }
            }
        }
    }
</script>